#include <fstream>              // file streams (i/o)
#include <iostream>             // std i/o with streams (cin, cout, cerr)
#include "tk_defs.h"
#include "grammar.h"
#include "dom.h"
#include "edic.h"
#include "ndic.h"
#include "func.h"
#include "autom.h"
#include "state.h"
using namespace std;

#ifndef _COMPILE_SAN_H_
#define _COMPILE_SAN_H_

//====================================================================================//
//   Peps Name Definitions                                                            //
//====================================================================================//

const int max_peps_name = 128;           // Maximum size (actually the last 4 are ".ext")

typedef char peps_name[max_peps_name];   // User Definided Names for any Peps Entity

const int max_peps_expr = 18192;         // Maximum size for expressions

typedef char peps_expr[max_peps_expr];   // User Definided expressions

const   int         peps_precision = 16; // precision to handle (i/o) rp values


#define EMPTY 0
#define DOMAIN 1
#define INTERVAL 2
#define CONSTANT 3
#define INTEGER 4
#define AUT 5
#define AUT_INTEGER 6
#define AUT_CONSTANT 7
#define AUT_DOMAIN 8

#define MAX_ID_NAME 128
#define MAX_AUT_NAME 128
#define MAX_STT_NAME 128
#define MAX_EXP_SIZE 18192

#define SYN 0
#define LOC 1

#define STT 0
#define FROM 1

#define CONTINUOUS 0
#define DISCRETE 1

#endif

class GRAMMAR;
class DOM;
class EDIC;
class NDIC;
class FUNC;
class AUTOMATON;
class STATE;
